package net.cattaka.android.variins.bean;

public class ToneInfo {
	public static final int DEFAULT_FREQUENCY = 440;
	private int frequency = 440;
	private float volume;

	public ToneInfo() {
		this.frequency = DEFAULT_FREQUENCY;
		this.volume = 0;
	}
	
	public ToneInfo(int frequency, float volume) {
		super();
		this.frequency = frequency;
		this.volume = volume;
	}

	public void set(ToneInfo src) {
		this.frequency = src.getFrequency();
		this.volume = src.getVolume();
	}

	public boolean isMute() {
		return (volume == 0 || frequency == 0);
	}
	
	@Override
	public String toString() {
		return "ToneInfo{frequency=" + frequency + ",volume" + volume + "}";
	}

	@Override
	public boolean equals(Object o) {
		if (o == null || !(o instanceof ToneInfo)) {
			return false;
		}
		ToneInfo ti = (ToneInfo)o;
		
		return (this.getFrequency() == ti.getFrequency()) && (this.volume == ti.getVolume());
	}

	public int getFrequency() {
		return frequency;
	}
	public void setFrequency(int frequency) {
		this.frequency = frequency;
	}
	public float getVolume() {
		return volume;
	}
	public void setVolume(float volume) {
		this.volume = volume;
	}
}
