package net.cattaka.android.variins.utils;

import android.media.AudioFormat;
import android.media.AudioManager;
import android.media.AudioTrack;
import android.util.Log;

public class TestPcm {
	private static String LOG_TAG = TestPcm.class.toString();
	private static AudioTrack audioTrack;
	
	private static final int SAMPLING_RATE = 8000;
	private static final int LENGTH = 3;
	public static void init() {
		int bufferSizeInBytes = android.media.AudioTrack.getMinBufferSize(
				SAMPLING_RATE, AudioFormat.CHANNEL_CONFIGURATION_MONO, AudioFormat.ENCODING_PCM_8BIT);
		
		audioTrack = new AudioTrack(
				AudioManager.STREAM_MUSIC,
				8000,
				AudioFormat.CHANNEL_CONFIGURATION_MONO,
				AudioFormat.ENCODING_PCM_8BIT,
				bufferSizeInBytes,
				AudioTrack.MODE_STREAM);
		
		audioTrack.setPlaybackPositionUpdateListener(new AudioTrack.OnPlaybackPositionUpdateListener() {
			@Override
			public void onPeriodicNotification(AudioTrack track) {
				Log.d("TestPcm", String.valueOf(track.getPlaybackHeadPosition()));
			}
			
			@Override
			public void onMarkerReached(AudioTrack track) {
				Log.d("TestPcm", "Reached");
			}
		});
	}
	
	public static void play() {
		Log.v(LOG_TAG,"Creating songdata.");
		byte[] part = {
			(byte)128,(byte)191,(byte)255,(byte)191,
			(byte)128,(byte)64,(byte)0,(byte)64
		};
		
		byte[] song = new byte[SAMPLING_RATE*LENGTH];
		
		for(int i=0;i<song.length;i++){
			int p = i%part.length;
			song[i] = part[p];
		}
		
		Log.d("TestPcm", String.valueOf(audioTrack.getPlaybackHeadPosition()));
		Log.v(LOG_TAG,"Stop()");
		audioTrack.stop();

		Log.v(LOG_TAG,"Play()");
		audioTrack.play();

		Log.v(LOG_TAG,"Writing..");
		audioTrack.write(song, 0, song.length);
		Log.d("TestPcm2", String.valueOf(audioTrack.getPlaybackHeadPosition()));

	}

}